#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef unsigned int SubInt;
typedef struct Uzel *Ref;

typedef struct Uzel
{
  SubInt X; // .
  SubInt Y; // 
  int Pay;  // .
  Ref Left; //   .
  Ref Right;//   .
};

typedef struct zveno *svqz;
typedef struct zveno
{
  unsigned int Element[256];
  svqz Sled;
  zveno();
};

zveno::zveno()
{
  for(int k=0;k<256;Element[k++]=0);
}

class Spisok
{
  private:
	 Ref Root;
	 void Search (int, int, int, Ref *);
	 void Poisk (svqz, SubInt, svqz *);
	 void Postroenie (svqz *);
	 void Udalenie (svqz *, svqz);
  public:
	 Spisok() { Root = NULL;} //  .
	 void Reshenie();
	 void Postr();
};

void Spisok::Search (int A, int B, int C, Ref *p)
// ,   A,B,C,   *p.
{
  if ( (*p) == NULL )
  {
	  (*p) = new (Uzel); (**p).X = A; (**p).Y = B; (**p).Pay = C;
	  (**p).Left = (**p).Right = NULL;
  }
  else
	  if ( C<=(**p).Pay ) Search (A,B,C,&((**p).Left));
	  else
		 if ( C>(**p).Pay ) Search (A,B,C,&((**p).Right));
}

void Spisok::Postroenie (svqz *UkStr)
//p  p 
//  ,   .
{
  svqz UkZv;
  int el;

  (*UkStr) = new (zveno);
  UkZv = (*UkStr); UkZv->Sled = NULL;
  cout << "  : \n";
  cin >> el;
  while ( el!=0 )
  {
	 UkZv->Sled = new (zveno); UkZv = UkZv->Sled;
	 UkZv->Element[el] = 1; UkZv->Sled = NULL;
	 cin >> el;
  }
}

void Spisok::Postr()
//p p,    .
{
  int A,B,C;

  cout << "    ,  \n";
  cout << "   ,  :\n";
  cin >> A >> B >> C;
  while ( A!=0 )
  { Search (A,B,C,&Root);
	 cin >> A >> B >> C;
  }
}

void Spisok::Poisk (svqz st, SubInt MENT, svqz *Res)
{
  svqz q;

  (*Res) = NULL; q = st->Sled;
  while  ( q != NULL  &&  (*Res) == NULL )
  {
	 if ( q->Element[MENT]==1 ) (*Res) = q;
	 else  q = q->Sled;
  }
}

void Spisok::Udalenie (svqz *zv, svqz UkStr)
//  p    
//,     zv.
{
	svqz Z;     //"p" .
	svqz UkZv1; //"H" .

	if ( (*zv)->Sled != NULL ) (**zv) = *((**zv).Sled);
	else
	{  Z = UkStr; UkZv1 = UkStr->Sled;
		while  (UkZv1 != (*zv))
		{ Z = UkZv1; UkZv1 = UkZv1->Sled; }
		Z->Sled = NULL; delete UkZv1;
	}
}

void Spisok::Reshenie()
{
  svqz UkStr;  //  .
  Ref UkUzel;  //    .
  Ref UkUzel1; //    .
  SubInt T1,T2;
  svqz Res1,Res2;

  //    .
  Postroenie (&UkStr);
  cout <<"    : ";
  while ( UkStr->Sled->Sled != NULL )
  {
	 UkUzel1 = Root;       //"" .
	 UkUzel  = Root->Left; //"" .
	 if ( UkUzel== NULL )
	 { //       ...
		T1 = Root->X; T2 = Root->Y;
		//...     .
		Root = Root->Right; delete UkUzel1;
	 }
	 else
	 { //       ...
		while ( UkUzel->Left != NULL )
		{
		  UkUzel1 = UkUzel1->Left;
		  UkUzel  = UkUzel->Left;
		}
		T1 = UkUzel->X; T2 = UkUzel->Y;
		//...     .
		UkUzel1->Left = UkUzel->Right;
		delete UkUzel;
	 }
	 // v  w  
	 // W1  W2  VS ...
	 Res1 = Res2 = NULL;
	 Poisk (UkStr,T1,&Res1);
	 Poisk (UkStr,T2,&Res2);
	 if ( Res1!=Res2 )
	 {
           for (int k=0;k<256;k++)
	     if ( Res1->Element[k]==1 || Res2->Element[k]==1 ) 
                     Res1->Element[k]=1;
             Udalenie (&Res2,UkStr);
             cout << "(" << T1 << " " << T2 << ")  ";
	 }
  }
}

void main ()
{
  Spisok Tree;
  Tree.Postr();
  Tree.Reshenie();
}

